subroutine ball2drawer(nballs, ndraw, nways, mvec, mdim)
implicit none
!
integer, intent(in)  :: nballs, ndraw, mdim
integer, intent(out) :: nways, mvec(mdim,*)  ! upon output, mvec(ndraw,nways)
!
integer   :: i, j, k
integer   :: ni, nj, nk, nl, istat, ncount
integer   :: ifrac, ifrac2
integer, allocatable :: ipoint(:)
external  :: ifrac, ifrac2
!
if (nballs .eq. 0) then
   nways = 1
   mvec(1:ndraw,1:nways) = 0
   return
end if
!
nways = ifrac2(ndraw,nballs) / ifrac(ndraw-nballs)
mvec(1:ndraw,1:nways) = 0
!
allocate(ipoint(nballs), STAT=istat)
!
ipoint(1:nballs - 1) = 1
ipoint(nballs)       = 0
!
ncount = 0
!
!write(6,*)' all possible cases for '
!write(6,*)' # of balls ', nballs, ' # of drawers ', ndraw
!call flush(6)
!
point: do 
!
! check pointer overflow
! 
   nj = nballs
   check: do
     ipoint(nj) = ipoint(nj) + 1
     if ( (ipoint(nj)) .le. ndraw ) then
      exit check
     else
      nj = nj - 1 
      if (nj >= 1) then
       cycle check
      else
       exit point
      endif
     endif
   end do check
   ipoint(nj+1:nballs) = ipoint(nj)
!
! record
!
   do ni=1,nballs-1
      do nj=ni+1,nballs
         if (ipoint(ni) .eq. ipoint(nj)) cycle point
      end do
   end do
!
   ncount = ncount + 1
   do nk=1,nballs
      mvec(ipoint(nk),ncount) = 1
   enddo
!   write(6,100)ncount, (ipoint(nl), nl=1,nballs)
   call flush(6)
end do point
!
100 format(6x, i3, '| ', 4x, 20(2x, I3))
!
! check
!
if (ncount .ne. nways) then
   write(6,*)
   write(6,*)'ball2drawer: error! ncount, nways', ncount, nways
   stop
endif
!write(6,*)
!do ni=1,nways
!   write(6,101)ni, (mvec(nj,ni),nj=1,ndraw)
!end do
!call flush(6)
101 format(i6, 10(1x,I1))
!
deallocate(ipoint, STAT=istat)

!
return
end subroutine ball2drawer
