subroutine pre_berezin
use random
use matmod
use tmpmatmod
use sdemod2
implicit none
include "../include/sizes"
include "../include/common"
!
integer :: ni, nj, nk, istat, nways
real*8  :: dtmp1, dtmp2, dtmp3
real*8  :: dfact0
complex*16 :: ctmp1, ctmp2
!
logical :: linc
integer :: ntmp1, ntmp2
integer :: ipt
integer, allocatable :: mvtmp1(:), mvtmp2(:)
!
mways = 0
!write(6,*)'pre_berezin: show mvec '
!call flush(6)
do ni=0,ndraw,1
   call ball2drawer(ni, ndraw, nways, mvec, ndraw)
   do nk=1,nways
      mways = mways + 1
!      write(6,101)mways, (mvec(nj,nk),nj=1,ndraw)
   end do
end do
!write(6,*)
!write(6,*)'pre_berezin: mways = ', mways
!call flush(6)
101 format(i6, 2x, 10(1x,I1))
!
allocate(mvec0(ndraw,mways), mindex(ndraw,mways), mtype(ndraw,mways), STAT=istat)
allocate(dfront(ndraw,mways), drear(ndraw,mways), STAT=istat)
allocate(mnzero(mways), STAT=istat)
allocate(nindex(mways), kindex(mways,ndraw/2), STAT=istat)
allocate(mvtmp1(ndraw), mvtmp2(ndraw), STAT=istat)
!
mtype = -1
dfront = 0.d0
drear = 0.d0
!
nk = 0
do ni=0,ndraw,1
   call ball2drawer(ni, ndraw, nways, mvec, ndraw)
   do nj=1,nways
      nk = nk + 1
      mvec0(1:ndraw,nk) = mvec(1:ndraw,nj)
   end do
end do
if (nk .ne. mways) then
   write(6,*)'pre_berezin: error! nk, mways ', nk, mways
   stop
end if
!
mnzero = 0
do ni=1,mways
   do nj=1,ndraw
      mnzero(ni) = mnzero(ni) + mvec0(nj,ni)
   end do
end do
!
do ni=1,mways
   mvtmp1(1:ndraw) = mvec0(1:ndraw,ni)
   do nj=1,ndraw
      mtype(nj,ni) = 0   ! not in the vector
      linc = .false.
      if ( mvtmp1(nj) .eq. 1 ) then
         mtype(nj,ni) = 1  ! in the vector
         linc = .true.
      end if
!
      dfact0 = 1.d0
      if (linc .and. mod(nj,2) .ne. 0) then
         dfact0 = -1.d0
      end if
!
      ntmp1 = 0
      ntmp2 = 0
      do nk=1,nj-1
         if ( mvtmp1(nk) .eq. 1 ) ntmp1 = ntmp1 + 1
      end do
      do nk=nj+1,ndraw
         if ( mvtmp1(nk) .eq. 1 ) ntmp2 = ntmp2 + 1
      end do
      if ( mod(ntmp1,2) .eq. 0 ) then
         dfront(nj,ni) = 1.d0 * dfact0
      else
         dfront(nj,ni) = -1.d0 * dfact0     
      end if
      if ( mod(ntmp2,2) .eq. 0 ) then
         drear(nj,ni) = 1.d0 * dfact0     
      else
         drear(nj,ni) = -1.d0 * dfact0     
      end if
!
      mvtmp2(1:ndraw) = mvtmp1(1:ndraw)
      if (linc) then
         mvtmp2(nj) = 0
      else
         mvtmp2(nj) = 1
      end if
!
      call findmvec(mvtmp2, ndraw, mvec0, mways, ipt)
      mindex(nj,ni) = ipt
      if (ipt .le. 0 .or. ipt .gt. mways) then
         write(6,*)'pre_berezin: error! ipt = ', ipt
         stop
      end if
!
   end do
end do
!
do ni=1,mways
   if (ni .eq. 1) then
      nindex(ni) = 1
      cycle
   end if
!
   mvtmp1(1:ndraw) = mvec0(1:ndraw,ni)
   ntmp1 = ni
   if (mvtmp1(1) .eq. 1 .and. mvtmp1(2) .eq. 1) then
      mvtmp1(1) = 0 
      mvtmp1(2) = 0 
      call findmvec(mvtmp1, ndraw, mvec0, mways, ipt)
      if (ipt .le. 0 .or. ipt .gt. mways) then
         write(6,*)'pre_berezin: error 1! ipt = ', ipt
         stop
      end if
      ntmp1 = ipt
   end if
   if (mvtmp1(3) .eq. 1 .and. mvtmp1(4) .eq. 1) then
      mvtmp1(3) = 0 
      mvtmp1(4) = 0 
      call findmvec(mvtmp1, ndraw, mvec0, mways, ipt)
      if (ipt .le. 0 .or. ipt .gt. mways) then
         write(6,*)'pre_berezin: error 2! ipt = ', ipt
         stop
      end if
      ntmp1 = ipt
   end if
   if (mvtmp1(5) .eq. 1 .and. mvtmp1(6) .eq. 1) then
      mvtmp1(5) = 0 
      mvtmp1(6) = 0 
      call findmvec(mvtmp1, ndraw, mvec0, mways, ipt)
      if (ipt .le. 0 .or. ipt .gt. mways) then
         write(6,*)'pre_berezin: error 3! ipt = ', ipt
         stop
      end if
      ntmp1 = ipt
   end if
   if (mvtmp1(7) .eq. 1 .and. mvtmp1(8) .eq. 1) then
      mvtmp1(7) = 0 
      mvtmp1(8) = 0 
      call findmvec(mvtmp1, ndraw, mvec0, mways, ipt)
      if (ipt .le. 0 .or. ipt .gt. mways) then
         write(6,*)'pre_berezin: error 4! ipt = ', ipt
         stop
      end if
      ntmp1 = ipt
   end if
   nindex(ni) = ntmp1
end do

do ni=1,mways
   kindex(ni,1:ndraw/2) = ni
   if (ni .eq. 1) cycle
!
   mvtmp1(1:ndraw) = mvec0(1:ndraw,ni)
   if (mvtmp1(1) .eq. 1 .and. mvtmp1(2) .eq. 1) then
      mvtmp1(1) = 0 
      mvtmp1(2) = 0 
      call findmvec(mvtmp1, ndraw, mvec0, mways, ipt)
      if (ipt .le. 0 .or. ipt .gt. mways) then
         write(6,*)'pre_berezin: error 5! ipt = ', ipt
         stop
      end if
      kindex(ni,1) = ipt
   end if
   mvtmp1(1:ndraw) = mvec0(1:ndraw,ni)
   if (mvtmp1(3) .eq. 1 .and. mvtmp1(4) .eq. 1) then
      mvtmp1(3) = 0 
      mvtmp1(4) = 0 
      call findmvec(mvtmp1, ndraw, mvec0, mways, ipt)
      if (ipt .le. 0 .or. ipt .gt. mways) then
         write(6,*)'pre_berezin: error 6! ipt = ', ipt
         stop
      end if
      kindex(ni,2) = ipt
   end if
   mvtmp1(1:ndraw) = mvec0(1:ndraw,ni)
   if (mvtmp1(5) .eq. 1 .and. mvtmp1(6) .eq. 1) then
      mvtmp1(5) = 0 
      mvtmp1(6) = 0 
      call findmvec(mvtmp1, ndraw, mvec0, mways, ipt)
      if (ipt .le. 0 .or. ipt .gt. mways) then
         write(6,*)'pre_berezin: error 7! ipt = ', ipt
         stop
      end if
      kindex(ni,3) = ipt
   end if
   mvtmp1(1:ndraw) = mvec0(1:ndraw,ni)
   if (mvtmp1(7) .eq. 1 .and. mvtmp1(8) .eq. 1) then
      mvtmp1(7) = 0 
      mvtmp1(8) = 0 
      call findmvec(mvtmp1, ndraw, mvec0, mways, ipt)
      if (ipt .le. 0 .or. ipt .gt. mways) then
         write(6,*)'pre_berezin: error 8! ipt = ', ipt
         stop
      end if
      kindex(ni,4) = ipt
   end if
end do


!
!write(6,*)
!write(6,*)' mindex '
!do ni=1,mways
!   write(6,102)ni, (mindex(nj,ni), nj=1,ndraw)
!end do 
!call flush(6)
!!
!write(6,*)
!write(6,*)' mtype '
!do ni=1,mways
!   write(6,102)ni, (mtype(nj,ni), nj=1,ndraw)
!end do 
!call flush(6)
!!
!write(6,*)
!write(6,*)' dfront '
!do ni=1,mways
!   write(6,102)ni, (int(dfront(nj,ni)), nj=1,ndraw)
!end do 
!call flush(6)
!!
!write(6,*)
!write(6,*)' drear  '
!do ni=1,mways
!   write(6,102)ni, (int(drear(nj,ni)), nj=1,ndraw)
!end do 
!call flush(6)
!!
!write(6,*)
!write(6,*)' mnzero '
!do ni=1,mways
!   write(6,102)ni, mnzero(ni)
!end do
!call flush(6)
!
!write(6,*)
!write(6,*)' nindex '
!do ni=1,mways
!   write(6,102)ni, nindex(ni)
!end do
!call flush(6)
!
102 format(I4, 1x, 10(1x,I3))
deallocate(mvtmp1, mvtmp2, STAT=istat) 
!
return
end subroutine pre_berezin
!

subroutine findmvec(mvin, nlen, mvec0, nentry, ipt)
implicit none
!
integer, intent(in) :: nlen, nentry
integer, intent(in) :: mvin(*), mvec0(nlen,*)
integer, intent(out) :: ipt
integer :: ni, nj, nk
!
ipt = -1
!
find0: do ni=1,nentry
   do nj=1,nlen
      if (mvin(nj) .ne. mvec0(nj,ni)) cycle find0
   end do
   ipt = ni
   exit find0
end do find0
!
return
end subroutine findmvec

