subroutine pre_berezin3
use random
use matmod
use tmpmatmod
use sdemod2
use sdemod3
implicit none
include "../include/sizes"
include "../include/common"
!
integer :: ni, nj, nk, istat, nways, ipt, jpt, nref
real*8  :: dtmp1, dtmp2, dtmp3
real*8  :: dfact0
complex*16 :: ctmp1, ctmp2
logical :: linc
integer :: ntmp1, ntmp2
integer, allocatable :: mvtmp1(:), mvtmp2(:)
!
mways = nstate**nopr
!
deallocate(mvec, STAT=istat)
allocate(mvec(nopr,mways), STAT=istat)
allocate(mvtmp1(nopr), mvtmp2(nopr), STAT=istat)
allocate(inup(nopr,mways), indn(nopr,mways), STAT=istat)
allocate(dfront_up(nopr,mways), drear_up(nopr,mways), STAT=istat)
allocate(dfront_dn(nopr,mways), drear_dn(nopr,mways), STAT=istat)
!
nways = 0
ipt = nopr
jpt = nopr
mvtmp1(1:nopr-1) = 1
mvtmp1(nopr) = 0
!write(6,*)'pre_berezin3: show mvec '
!call flush(6)
do while (jpt .gt. 0) 
   ntmp1 = mvtmp1(nopr) + 1
   if (ntmp1 .le. nstate) then
      mvtmp1(nopr) = ntmp1
   else if ( mvtmp1(ipt)+1 .le. nstate ) then
      mvtmp1(ipt) = mvtmp1(ipt) + 1
      mvtmp1(ipt+1:nopr) = 1
   else
      do while (mvtmp1(ipt)+1 .gt. nstate .and. ipt-1 .gt. jpt) 
         ipt = ipt -1
      end do
      if (mvtmp1(ipt)+1 .le. nstate) then
         mvtmp1(ipt) = mvtmp1(ipt) + 1
         mvtmp1(ipt+1:nopr) = 1
         ipt = nopr -1 
         nways = nways + 1
         mvec(1:nopr,nways) = mvtmp1(1:nopr)
!         write(6,103)nways, (mvtmp1(nj), nj=1,nopr)! , ipt, jpt
!         call flush(6)
         cycle
      end if
!
      if (ipt-1 .le. jpt) then
         ntmp2 = mvtmp1(jpt) + 1
         if (ntmp2 .le. nstate) then
             mvtmp1(jpt) = mvtmp1(jpt) + 1
             mvtmp1(jpt+1:nopr) = 1
             ipt = nopr - 1
         else 
             jpt = jpt - 1
             if (jpt .le. 0) exit
             mvtmp1(jpt) = mvtmp1(jpt) + 1
             mvtmp1(jpt+1:nopr) = 1
             ipt = nopr - 1
         end if
      else
         ipt = ipt - 1
         mvtmp1(ipt) = mvtmp1(ipt) + 1
         mvtmp1(ipt+1:nopr) = 1
         ipt = nopr -1 
      end if
   end if
   nways = nways + 1
   mvec(1:nopr,nways) = mvtmp1(1:nopr)
!   write(6,103),nways, (mvtmp1(nj), nj=1,nopr)
!   call flush(6)
end do
103 format(i6, 2x, 10(1x,I1))
!
! check
!
write(6,*)
write(6,*)'pre_berezin3: mways = ', mways
if (nways .ne. mways) then
   write(6,*)'pre_berezin3: error mvec! mways, nways ', mways, nways
   stop
end if
!
inup(1:nopr,1:mways) = -1   ! -1 means the state is destroyed
indn(1:nopr,1:mways) = -1    
!
! up
loopi: do ni=1,mways
   loopj: do nj=1,nopr
      mvtmp1(1:nopr) = mvec(1:nopr,ni)
      mvtmp1(nj) = mvtmp1(nj) + 1
      if (mvtmp1(nj) .gt. nstate) then
         cycle loopj
      end if
      call findmvec(mvtmp1, nopr, mvec, mways, nk)
      if (nk .lt. 0) then
         write(6,*)'pre_berezin3: error constructing ladder up operator '
         write(6,*)'ni, nj, nk ', ni, nj, nk
         stop
      else
         inup(nj,ni) = nk
      end if
   end do loopj
end do loopi
!
! down
loopm: do ni=1,mways
   loopn: do nj=1,nopr
      mvtmp1(1:nopr) = mvec(1:nopr,ni)
      mvtmp1(nj) = mvtmp1(nj) - 1
      if (mvtmp1(nj) .lt. 1) then
         cycle loopn
      end if
      call findmvec(mvtmp1, nopr, mvec, mways, nk)
      if (nk .lt. 0) then
         write(6,*)'pre_berezin3: error constructing ladder down operator '
         write(6,*)'ni, nj, nk ', ni, nj, nk
         stop
      else
         indn(nj,ni) = nk
      end if
   end do loopn
end do loopm
!
!write(6,*)
!write(6,*)'pre_berenzin3: show inup '
!do ni=1,mways
!   do nj=1,nopr
!      write(6,*)ni, nj, inup(nj,ni)
!   end do
!end do
!write(6,*)'pre_berenzin3: show indn '
!do ni=1,mways
!   do nj=1,nopr
!      write(6,*)ni, nj, indn(nj,ni)
!   end do
!end do
!call flush(6)
!
dfront_up = 1.d0
drear_up  = 1.d0
dfront_dn = 1.d0
drear_dn  = 1.d0
!
nref = (nstate + 1) / 2
do ni=1,mways
   do nj=1,nopr
      mvtmp1(1:nopr) = mvec(1:nopr,ni) - nref
      ntmp1 = 0
      do ipt=1,nj-1 
         ntmp1 = ntmp1 + abs(mvtmp1(ipt))
      end do
      ntmp2 = ntmp1 + abs(mvtmp1(nj))
      if ( mod(ntmp1, 2) .eq. 0 ) then
          dfront_dn(nj,ni) = 1.d0
      else
          dfront_dn(nj,ni) = -1.d0
      end if
      if ( mod(ntmp2, 2) .eq. 0 ) then
          dfront_up(nj,ni) = 1.d0
      else
          dfront_up(nj,ni) = -1.d0
      end if
! 
      ntmp1 = 0
      do ipt=nj+1,nopr
         ntmp1 = ntmp1 + abs(mvtmp1(ipt))
      end do
      ntmp2 = ntmp1 + abs(mvtmp1(nj))
      if ( mod(ntmp1, 2) .eq. 0 ) then
          drear_up(nj,ni) = 1.d0
      else
          drear_up(nj,ni) = -1.d0
      end if
      if ( mod(ntmp2, 2) .eq. 0 ) then
          drear_dn(nj,ni) = 1.d0
      else
          drear_dn(nj,ni) = -1.d0
      end if
   end do
end do
!open(unit=113, file='ladder_oper', status='unknown')
!rewind(113)
!
!do ni=1,mways
!do nj=1,nopr
!write(113,195) inup(nj,ni), indn(nj,ni), dfront_up(nj,ni), dfront_dn(nj,ni), drear_up(nj,ni),drear_dn(nj,ni)
!end do
!end do
!195 format(2I,4f12.1)
!call flush(113)
!
!write(6,*)
!write(6,*)'pre_berenzin3: show dfront_up '
!do ni=1,mways
!   do nj=1,nopr
!      write(6,*)ni, nj, dfront_up(nj,ni)
!   end do
!end do
!write(6,*)'pre_berenzin3: show dfront_dn '
!do ni=1,mways
!   do nj=1,nopr
!      write(6,*)ni, nj, dfront_dn(nj,ni)
!   end do
!end do
!write(6,*)'pre_berenzin3: show drear_up '
!do ni=1,mways
!   do nj=1,nopr
!      write(6,*)ni, nj, drear_up(nj,ni)
!   end do
!end do
!write(6,*)'pre_berenzin3: show drear_dn '
!do ni=1,mways
!   do nj=1,nopr
!      write(6,*)ni, nj, drear_dn(nj,ni)
!   end do
!end do
!call flush(6)
!
mvtmp1(1:nopr) = nref
call findmvec(mvtmp1, nopr, mvec, mways, index_vac)
write(6,*)
write(6,*)'pre_berezin3: index_vac = ', index_vac
call flush(6)

!
deallocate(mvtmp1, mvtmp2, STAT=istat) 
!
return
end subroutine pre_berezin3
!

