subroutine evaluatepara
use matmod
use tmpmatmod
implicit none
include "../include/sizes"
include "../include/common"
!
integer :: nballs, nways
integer :: ni,istat
integer :: ifrac, ifrac2
external :: ifrac, ifrac2
!
namelist  / tdjob / lopen, ntime, dt
namelist  / hamil / engy1, engy2, t12, u1, e1u, e1d
namelist  / dfield5 / egate, ton_gate, toff_gate
namelist  / sde / ntraj, dref
namelist  / ladder / nstate
!
nsgn  = 2
!nspin = 1 
nspin = 2
norbs = 1 
nsys  = 2 * nspin
nrho  = nsys**norbs
!
nstate = 3
!nstate = 5
rewind(5)
read(5, ladder, end=99)
99 continue
if (nstate .lt. 3 .or. mod(nstate,2) .ne. 1) then
   write(6,*)
   write(6,*)'evaluatepara: error! unknown nstate ', nstate
   stop
end if
!
nopr = nsgn * nspin   ! iopr = (isgn-1)*nspin+ispin
!
ndraw = 2 * nsgn * nspin
!ndraw = 4
nways = 1
do nballs=1,ndraw,1
   nways = max(ifrac2(ndraw,nballs) / ifrac(ndraw-nballs), nways)
end do
maxways = nways
!
iptst0 = 1
iptst1 = 1
do ni=1,ndraw
   iptst1 = iptst1 + 2**(ni-1)
end do
!
allocate(mvec(ndraw,maxways), STAT=istat)
mvec = 0
!
! tdjob
!
lopen = .false.
dt = 0.002d0
ntime = 100000
rewind(5)
read(5, tdjob, end=100)
100 continue
!
! hamiltonian
!
engy1 = -1.d0
engy2 =  1.d0
t12   =  1.d0
u1    =  0.d0
e1u   = -1.d0
e1d   = -1.d0
rewind(5)
read(5, hamil, end=101)
101 continue
t12 = dabs(t12)  ! set t12 to be positive
!
! sde
! 
dref  = 1.d0
ntraj = 1000
rewind(5)
read(5, sde, end=102)
102 continue
!
egate = 0.d0
ton_gate = 0.1d0
toff_gate = 0.2d0
rewind(5)
read(5, dfield5, end=103)
103 continue
!
return
end subroutine evaluatepara
