subroutine fermifunc(isgn,npole_psd,cpcof,cpole, cin, cout)
use matmod
implicit none
!
! cout is actually independent of isgn, as long as cppole(ni,1) and cppole(ni,2) are 
! complex conjugate to each other 
!
include "../include/sizes"
include "../include/common"
!
! Pade (PSD) expansion for Fermi funtion 1/(e^x + 1)
!
integer, intent(in) :: isgn,npole_psd
complex*16, intent(in) :: cin,cpcof(npole_psd),cpole(npole_psd,nsgn)
complex*16, intent(out) :: cout
integer  :: ni
!
cout = dcmplx(5.d-1, 0.d0)
do ni=1,npole_psd
   cout = cout + cpcof(ni) / (cin + cpole(ni,isgn)) + &
                 cpcof(ni) / (cin - cpole(ni,isgn))

end do
!
end subroutine fermifunc
