subroutine allocatememory
use matmod
use tmpmatmod
implicit none
include '../include/sizes'
include '../include/common'
!
integer :: istat
!
allocate(rho(nrho,nrho), STAT=istat)
allocate(drho(nrho,nrho), STAT=istat)
allocate(rho1(nsys,nsys), STAT=istat)
allocate(rho2(nsys,nsys), STAT=istat)
rho = czero
drho = czero
rho1 = czero
!rho2 = czero
!
allocate(ams(nrho,nrho), STAT=istat)
allocate(amsall(nrho,nrho,norbs,nspin), STAT=istat)
allocate(amsori(nrho,nrho,norbs,nspin), STAT=istat)
ams    = 0.d0
amsall = 0.d0
amsori = 0.d0
!
allocate(dmtmp1(nrho,nrho), dmtmp2(nrho,nrho), STAT=istat)
allocate(dmtmp3(nrho,nrho), dmtmp4(nrho,nrho), STAT=istat)
allocate(dmtmp5(nrho,nrho), dmtmp6(nrho,nrho), STAT=istat)
dmtmp1 = 0.d0
dmtmp2 = 0.d0
dmtmp3 = 0.d0
dmtmp4 = 0.d0
dmtmp5 = 0.d0
dmtmp6 = 0.d0
!
allocate(cmtmp1(nrho,nrho), cmtmp2(nrho,nrho), STAT=istat)
allocate(cmtmp3(nrho,nrho), cmtmp4(nrho,nrho), STAT=istat)
allocate(cmtmp5(nrho,nrho), cmtmp6(nrho,nrho), STAT=istat)
allocate(cmtmp7(nrho,nrho), cmtmp8(nrho,nrho), STAT=istat)
cmtmp1 = czero
cmtmp2 = czero
cmtmp3 = czero
cmtmp4 = czero
cmtmp5 = czero
cmtmp6 = czero
cmtmp7 = czero
cmtmp8 = czero
!
allocate(zmtmp1(nrho,nrho), zmtmp2(nrho,nrho), STAT=istat)
zmtmp1 = czero
zmtmp2 = czero
!
end subroutine allocatememory
!
!------------
subroutine freememory
use matmod
use tmpmatmod
use anderson
implicit none
include '../include/sizes'
include '../include/common'
!
integer :: istat
!
deallocate(cpeigv_1, cpcoef_1, cppole_1, STAT=istat)
deallocate(cpeigv_2, cpcoef_2, cppole_2, STAT=istat)
deallocate(cgama_1, coefb_1, STAT=istat)
deallocate(cgama_2, coefb_2, STAT=istat)
deallocate(dpm, STAT=istat)
deallocate(mvec, ijvecr, STAT=istat)
deallocate(rho, drho, rho1, rho2, STAT=istat)
deallocate(ams, STAT=istat)
deallocate(amsall, amsori, STAT=istat)
deallocate(rowams, colams, sgnams, valams, STAT=istat)
deallocate(premat, STAT=istat)
deallocate(rowpre, colpre, valpre, STAT=istat)
deallocate(irow_a, icol_a, dval_a, STAT=istat)
!
deallocate(dmtmp1, dmtmp2, dmtmp3, dmtmp4, dmtmp5, dmtmp6, STAT=istat)
deallocate(cmtmp1, cmtmp2, cmtmp3, cmtmp4, cmtmp5, cmtmp6, cmtmp7, cmtmp8, STAT=istat)
deallocate(zmtmp1, zmtmp2, STAT=istat)
!
end subroutine freememory
