subroutine setlead1
use matmod
use tmpmatmod
implicit none
include "../include/sizes"
include "../include/common"
!
integer :: istat, ni, nj, nk
real*8  :: dxip   
real*8  :: ttmin, ttmax, dtt, tt
complex*16 :: ctmp1, ctmp2
!
namelist / leadno / nlead
namelist / firstleadinfo / dinvbeta_1, bandcenter_1, bandwidth_1, linewidth_1, npole_psd_1
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! 1st lead
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
npole_lor_1 = 1
npole_psd_1 = 20
dinvbeta_1 = 0.01d0
bandwidth_1 = 5.d0
bandcenter_1 = 0.d0
linewidth_1 = 0.2d0
rewind(5)
read(5, leadno, end=100)
read(5, firstleadinfo, end=100)
100 continue
!
npoles_1 = npole_psd_1 + npole_lor_1
!
write(6,*) 
write(6,*)'setlead: 1stlead parameters  '
write(6,*)'setlead: temperature = ', dinvbeta_1
write(6,*)'setlead: bandcenter  = ', bandcenter_1
write(6,*)'setlead: bandwidth   = ', bandwidth_1
write(6,*)'setlead: linewidth   = ', linewidth_1
write(6,*)'setlead: npole_psd   = ', npole_psd_1
call flush(6)
!
dinvbeta_1 = dinvbeta_1 / hbar
bandcenter_1 = bandcenter_1 / hbar
bandwidth_1 = bandwidth_1 / hbar
linewidth_1 = linewidth_1 / hbar
!
allocate(cpeigv_1(npole_psd_1), cpcoef_1(npole_psd_1), cppole_1(npole_psd_1, nsgn), STAT=istat)
allocate(cgama_1(npoles_1, nsgn), coefb_1(npoles_1, nsgn), STAT=istat)
allocate(dpm(nsgn), STAT=istat)
!
dpm(1) = 1.d0
dpm(2) = -1.d0
!
call zpout_psd(npole_psd_1, nsgn, cpeigv_1, cpcoef_1, cppole_1)
!
dxip = linewidth_1 * bandwidth_1**2 * 5.d-1
!
do ni=1,nsgn
! Lorentzian pole
   cgama_1(1,ni) = dcmplx(-bandwidth_1, dpm(ni)*bandcenter_1)
   ctmp1 = dcmplx(dpm(ni)*bandcenter_1, bandwidth_1) / dinvbeta_1   
   call fermifunc(ni,npole_psd_1,cpcoef_1,cppole_1, ctmp1, ctmp2)
   coefb_1(1,ni) = dxip / bandwidth_1 * ctmp2
! Pade poles
   do nk=1,npole_psd_1
      nj = nk + 1
      cgama_1(nj,ni) = dpm(ni) * eye * dinvbeta_1 * cppole_1(nk,ni)     
      coefb_1(nj,ni) = eye * 2.d0 * cpcoef_1(nk) * dxip * dinvbeta_1 /                &
                     ( (cppole_1(nk,ni)*dinvbeta_1 - bandcenter_1)**2 + bandwidth_1**2 )
   end do
end do
!
ttmin = 0.d0
ttmax = 2.d0
dtt   = 1.d-3
tt    = ttmin
!
open(unit=10, file='1stleadcorr.data', status='unknown')
rewind(10)
!
do while (tt .le. ttmax)
ctmp1 = czero
ctmp2 = czero
do nk=1,npoles_1
   ctmp1 = ctmp1 + coefb_1(nk,1) * cdexp(cgama_1(nk,1) * tt)
   ctmp2 = ctmp2 + coefb_1(nk,2) * cdexp(cgama_1(nk,2) * tt)
end do
write(10,520)tt, dble(ctmp1), dimag(ctmp1), dble(ctmp2), dimag(ctmp2)
call flush(10)
tt = tt + dtt
end do
!
close(10)
520 format(f12.6, 2x, 4(e13.4e3, 2x))
end subroutine setlead1
