subroutine setlead2
use matmod
use tmpmatmod
implicit none
include "../include/sizes"
include "../include/common"
!
integer :: istat, ni, nj, nk, k
real*8  :: dxip   
real*8  :: ttmin, ttmax, dtt, tt
complex*16 :: ctmp1, ctmp2
!
namelist / secondleadinfo / dinvbeta_2, bandcenter_2, bandwidth_2, linewidth_2, npole_psd_2
!
npole_lor_2 = 1
npole_psd_2 = 8
dinvbeta_2 = 0.5d0
bandwidth_2 = 5.d0
bandcenter_2 = 0.d0
linewidth_2 = 0.5d0
rewind(5)
read(5, secondleadinfo, end=100)
100 continue
!
npoles_2 = npole_psd_2 + npole_lor_2
!
write(6,*)
write(6,*)'setlead: 2ndlead parameters  '
write(6,*)'setlead: temperature = ', dinvbeta_2
write(6,*)'setlead: bandcenter  = ', bandcenter_2
write(6,*)'setlead: bandwidth   = ', bandwidth_2
write(6,*)'setlead: linewidth   = ', linewidth_2
write(6,*)'setlead: npole_psd   = ', npole_psd_2
call flush(6)
!
dinvbeta_2 = dinvbeta_2 / hbar
bandcenter_2 = bandcenter_2 / hbar
bandwidth_2 = bandwidth_2 / hbar
linewidth_2 = linewidth_2 / hbar
!
allocate(cpeigv_2(npole_psd_2), cpcoef_2(npole_psd_2), cppole_2(npole_psd_2, nsgn), STAT=istat)
allocate(cgama_2(npoles_2, nsgn), coefb_2(npoles_2, nsgn), STAT=istat)
!
dpm(1) = 1.d0
dpm(2) = -1.d0
!
call zpout_psd(npole_psd_2, nsgn, cpeigv_2, cpcoef_2, cppole_2)
!
dxip = linewidth_2 * bandwidth_2**2 * 5.d-1
!
do ni=1,nsgn
! Lorentzian pole
   cgama_2(1,ni) = dcmplx(-bandwidth_2, dpm(ni)*bandcenter_2)
   ctmp1 = dcmplx(dpm(ni)*bandcenter_2, bandwidth_2) / dinvbeta_2   
   call fermifunc(ni,npole_psd_2,cpcoef_2,cppole_2, ctmp1, ctmp2)
   coefb_2(1,ni) = dxip / bandwidth_2 * ctmp2
! Pade poles
   do nk=1,npole_psd_2
      nj = nk + 1
      cgama_2(nj,ni) = dpm(ni) * eye * dinvbeta_2 * cppole_2(nk,ni)     
      coefb_2(nj,ni) = eye * 2.d0 * cpcoef_2(nk) * dxip * dinvbeta_2 /                &
                     ( (cppole_2(nk,ni)*dinvbeta_2 - bandcenter_2)**2 + bandwidth_2**2 )
   end do
end do
!
ttmin = 0.d0
ttmax = 2.d0
dtt   = 1.d-3
tt    = ttmin
!
open(unit=10, file='2ndleadcorr.data', status='unknown')
rewind(10)
!
do while (tt .le. ttmax)
ctmp1 = czero
ctmp2 = czero
do nk=1,npoles_2
   ctmp1 = ctmp1 + coefb_2(nk,1) * cdexp(cgama_2(nk,1) * tt)
   ctmp2 = ctmp2 + coefb_2(nk,2) * cdexp(cgama_2(nk,2) * tt)
end do
write(10,520)tt, dble(ctmp1), dimag(ctmp1), dble(ctmp2), dimag(ctmp2)
call flush(10)
tt = tt + dtt
end do
!
520 format(f12.6, 2x, 4(e13.4e3, 2x))
close(10)
!
end subroutine setlead2
