module matmod
implicit none
!
integer,    save, allocatable :: mvec(:,:)             ! mvec(ndraw,maxways)
integer,    save, allocatable :: ijvecr(:,:)           ! ijvecr(norbs,nauxdr)
!
complex*16, save, allocatable :: hs(:,:)                 ! Hamiltonian with dimension (nrho, nrho) (should be Hermitian)
complex*16, save, allocatable :: rho(:,:)                ! density matrix 
complex*16, save, allocatable :: rho1(:,:)               ! density matrix of orbital-1
complex*16, save, allocatable :: rho2(:,:)               ! density matrix of orbital-2
!
real*8,     save, allocatable :: ams(:,:)                ! a_{ms} and a^\dag_{ms}
real*8,     save, allocatable :: amsall(:,:,:,:)
real*8,     save, allocatable :: amsori(:,:,:,:)
integer,    save, allocatable :: rowams(:,:,:), colams(:,:,:)
integer,    save, allocatable :: sgnams(:,:,:)           ! 0 for plus sign, and others for minus sign
real*8,     save, allocatable :: valams(:,:,:)
!
real*8,     save, allocatable :: premat(:,:)
integer,    save, allocatable :: rowpre(:), colpre(:)
real*8,     save, allocatable :: valpre(:)
!
! time-evolution
!
complex*16, save, allocatable :: drho(:,:)       
!
! Pade
!
real*8,     save, allocatable :: dpm(:)
complex*16, save, allocatable :: cpeigv_1(:), cpcoef_1(:), cppole_1(:,:)
complex*16, save, allocatable :: cpeigv_2(:), cpcoef_2(:), cppole_2(:,:)
complex*16, save, allocatable :: cgama_1(:,:), coefb_1(:,:)
complex*16, save, allocatable :: cgama_2(:,:), coefb_2(:,:)
!



end module matmod
