subroutine sde_euler17_open
use matmod
use tmpmatmod
use sdemod
use sdemod2
use sdemod3
use anderson
use random
use omp_lib
implicit none
include "../include/sizes"
include "../include/common"
!
integer :: it, istat, ispin,sspin, itraj, ni, nj, nk,n1,n3, ilead,on,off
real*8  :: tt
real*8  :: occu, occd, occ1, occ2
real*8  :: left_spin1_curr, right_spin1_curr
real*8  :: left_spin2_curr, right_spin2_curr
real*8  :: tlam, dcp, dcm, dtmp1
real*8, allocatable  :: dvec1(:), dvec2(:), dvec3(:), dvec4(:)
real*8  :: std_dv1, std_dv2, std_dv3, std_dv4
real*8  :: std_dv5, std_dv6, std_dv7, std_dv8
complex*16 :: mean1,mean2,mean3,mean4,mean5,mean6,mean7,mean8
complex*16, allocatable :: w1s(:,:,:), w2s(:,:,:)
complex*16, allocatable :: w3s(:,:,:), w4s(:,:,:)
complex*16,allocatable :: Arho(:,:,:)
complex*16 :: cb, cd,ctmp1, ctmp2, ctmp3
integer, allocatable :: iseed(:)
complex*16, allocatable :: rgtmp1(:,:,:), rgtmp2(:,:,:)
complex*16, allocatable :: zcorr(:,:,:)
complex*16, allocatable :: curr1(:,:,:),curr2(:,:,:),curr3(:,:,:),curr4(:,:,:)
complex*16, allocatable :: curr1_1(:,:),curr2_2(:,:),curr3_3(:,:),curr4_4(:,:)
!
namelist / seedinfo / lread_seed, noffset_seed
!
allocate(w1s(ntraj,ntime,nspin*nlead), w2s(ntraj,ntime,nspin*nlead), &
         w3s(ntraj,ntime,nspin*nlead), w4s(ntraj,ntime,nspin*nlead), STAT=istat)
allocate(dvec1(ntime), dvec2(ntime), dvec3(ntime), dvec4(ntime), STAT=istat)
allocate(zcorr(ntime,nsgn,nlead), STAT=istat)
!
open(unit=8, file='population.dat', status='unknown')
rewind(8)
open(unit=9, file='rhoavg.data', form='unformatted', status='unknown')
rewind(9)
open(unit=19, file='1current.dat', status='unknown')
rewind(19)
open(unit=29, file='2current.dat', status='unknown')
rewind(29)

!
write(6,*)
write(6,*)'sde_euler17_open: time evolution '
write(6,*)'sde_euler17_open:   dt = ', dt
write(6,*)'sde_euler17_open: tmax = ', dble(ntime-1)*dt
write(6,*)'sde_euler17_open:   e1u = ', e1u  
write(6,*)'sde_euler17_open:   e1d = ', e1d  
write(6,*)'sde_euler17_open:    u1 = ', u1   
write(6,*)'sde_euler17_open: dref  = ', dref 
write(6,*)'sde_euler17_open: ntraj = ', ntraj

call flush(6)
!
nrhog = 4
cb    = dsqrt(5.d-1) * dcmplx(1.d0, -1.d0)
cd    = dsqrt(5.d-1) * dcmplx(1.d0,  1.d0)
!
e1u   = e1u / hbar
e1d   = e1d / hbar
u1    = u1 / hbar
dref  = dref / hbar
t12   = dref
tlam  = dsqrt(dref)
!
egate = egate / hbar
if ( dabs(egate) .gt. dpico ) then
   write(6,*)'sde_euler17_open:     egate = ', egate*hbar
   write(6,*)'sde_euler17_open:  ton_gate = ', ton_gate
   write(6,*)'sde_euler17_open: toff_gate = ', toff_gate
end if
call flush(6)
!
allocate(v1s(ntraj,ntime,nspin*nlead), v2s(ntraj,ntime,nspin*nlead), &
         v3s(ntraj,ntime,nspin*nlead), v4s(ntraj,ntime,nspin*nlead), STAT=istat)
!
!!!!!!!!!!!
call pre_anderson
call pre_berezin3
!!!!!!!!!!!
allocate(rhog1(nrhog,nrhog,mways), STAT=istat)
allocate(drhog1(nrhog,nrhog,mways), STAT=istat)
allocate(Arho(nrhog,nrhog,mways), STAT=istat)
allocate(rhosav(nrhog,nrhog,ntime), STAT=istat)
allocate(rgtmp1(nrhog,nrhog,mways), rgtmp2(nrhog,nrhog,mways), STAT=istat)
!
allocate(curr1(nrhog,nrhog,ntime), STAT=istat)
allocate(curr2(nrhog,nrhog,ntime), STAT=istat)
allocate(curr3(nrhog,nrhog,ntime), STAT=istat)
allocate(curr4(nrhog,nrhog,ntime), STAT=istat)
!
allocate(curr1_1(nrhog,nrhog), STAT=istat)
allocate(curr2_2(nrhog,nrhog), STAT=istat)
allocate(curr3_3(nrhog,nrhog), STAT=istat)
allocate(curr4_4(nrhog,nrhog), STAT=istat)
!
zcorr = czero
do it=1,ntime
   tt = dble(it - 1) * dt
   do ni=1,nsgn
      do nj=1,npoles_1
         zcorr(it,ni,1) = zcorr(it,ni,1) + coefb_1(nj,ni) * cdexp(cgama_1(nj,ni) * tt)
      end do
      zcorr(it,ni,1)=zcorr(it,ni,1)*Vt1(ni,it)
   end do
end do
if (nlead .eq. 2) then
do it=1,ntime
   tt = dble(it - 1) * dt
   do ni=1,nsgn
      do nj=1,npoles_2
         zcorr(it,ni,2) = zcorr(it,ni,2) + coefb_2(nj,ni) * cdexp(cgama_2(nj,ni) * tt)
      end do
      zcorr(it,ni,2) = zcorr(it,ni,2)*Vt2(ni,it)
   end do
end do
end if
!   goto 999
!
lread_seed = .false.
noffset_seed = 0
rewind(5)
read(5, seedinfo, end=100)
100 continue
!
if (lread_seed) then
   open(unit=11, file='seed.data', form='unformatted', status='unknown')
   call RANDOM_SEED(size=nk)
   allocate(iseed(nk), STAT=istat)
!
   do ispin=1,nspin*nlead  ! no indent
   do it=1,ntime
      read(11) (iseed(ni), ni=1,nk)
      call RANDOM_SEED(put=iseed)
      do ni=1,noffset_seed
         dtmp1 = random_normal()
      end do
      do itraj=1,ntraj   
         v1s(itraj,it,ispin) = random_normal()
      end do
!
      read(11) (iseed(ni), ni=1,nk)
      call RANDOM_SEED(put=iseed)
      do ni=1,noffset_seed
         dtmp1 = random_normal()
      end do
      do itraj=1,ntraj   
         v2s(itraj,it,ispin) = random_normal()
      end do
!
      read(11) (iseed(ni), ni=1,nk)
      call RANDOM_SEED(put=iseed)
      do ni=1,noffset_seed
         dtmp1 = random_normal()
      end do
      do itraj=1,ntraj   
         v3s(itraj,it,ispin) = random_normal()
      end do
!
      read(11) (iseed(ni), ni=1,nk)
      call RANDOM_SEED(put=iseed)
      do ni=1,noffset_seed
         dtmp1 = random_normal()
      end do
      do itraj=1,ntraj   
         v4s(itraj,it,ispin) = random_normal()
      end do
   end do
   end do ! loop ispin
   close(11)
   deallocate(iseed, STAT=istat)
   write(6,*)
   write(6,*)'sde_euler17_open: random seed read from file '
   write(6,*)'sde_euler17_open: with ', noffset_seed, ' void rand num '
   call flush(6)
!
else
   open(unit=11, file='seed.data', form='unformatted', status='unknown')
   rewind(11)
   !
   call RANDOM_SEED(size=nk)
   allocate(iseed(nk), STAT=istat)
   !
   do ispin=1,nspin*nlead
   do it=1,ntime
      call init_random_seed_out(nk, iseed)
      do itraj=1,ntraj   
         v1s(itraj,it,ispin) = random_normal()
      end do
      write(11) (iseed(ni), ni=1,nk)
      call delay(51200)
   !
      call init_random_seed_out(nk, iseed)
      do itraj=1,ntraj   
         v2s(itraj,it,ispin) = random_normal()
      end do
      write(11) (iseed(ni), ni=1,nk)
      call delay(51200)
   !
      call init_random_seed_out(nk, iseed)
      do itraj=1,ntraj   
         v3s(itraj,it,ispin) = random_normal()
      end do
      write(11) (iseed(ni), ni=1,nk)
      call delay(51200)
   !
      call init_random_seed_out(nk, iseed)
      do itraj=1,ntraj   
         v4s(itraj,it,ispin) = random_normal()
      end do
      write(11) (iseed(ni), ni=1,nk)
      call delay(51200)
   end do
   end do
   close(11)
   deallocate(iseed, STAT=istat)
   write(6,*)
   write(6,*)'sde_euler17_open: random seeds generated and saved '
   call flush(6)
end if
!
v1s = v1s / dsqrt(dt)
v2s = v2s / dsqrt(dt)
v3s = v3s / dsqrt(dt)
v4s = v4s / dsqrt(dt)
!
w1s = czero  
w2s = czero
w3s = czero
w4s = czero
!$OMP PARALLEL DO default(none) shared(zcorr,dt,nspin,nlead,ntraj,ntime,w1s,w2s,w3s,w4s,v1s,v2s,v3s,v4s) &
!$OMP private(ilead,ispin,itraj,it,dvec1,dvec2,dvec3,dvec4)
do ispin=1,nspin*nlead
if (ispin .lt. 3) then
        ilead=1
else
        ilead=2
end if
do itraj=1,ntraj
   dvec1(1:ntime) = dble(zcorr(1:ntime,1,ilead))  ! x: C+ - real part
   dvec2(1:ntime) = v1s(itraj,1:ntime,ispin)       ! h: v1
   call ddcon(dvec2, 1, dvec1, 1, dvec3, 1, ntime, ntime, 0, ntime, 1)    
   dvec1(1:ntime) = dimag(zcorr(1:ntime,1,ilead)) ! x: C+ - imag part
   call ddcon(dvec2, 1, dvec1, 1, dvec4, 1, ntime, ntime, 0, ntime, 1)    
   do it=1,ntime
      w1s(itraj,it,ispin) = dcmplx(dvec3(it), dvec4(it)) * dt
   end do  
!
   dvec1(1:ntime) = dble(zcorr(1:ntime,2,ilead))  ! x: C- - real part
   dvec2(1:ntime) = v2s(itraj,1:ntime,ispin)       ! h: v2
   call ddcon(dvec2, 1, dvec1, 1, dvec3, 1, ntime, ntime, 0, ntime, 1)    
   dvec1(1:ntime) = dimag(zcorr(1:ntime,2,ilead)) ! x: C- - imag part
   call ddcon(dvec2, 1, dvec1, 1, dvec4, 1, ntime, ntime, 0, ntime, 1)    
   do it=1,ntime
      w2s(itraj,it,ispin) = dcmplx(dvec3(it), dvec4(it)) * dt
   end do  
!
   dvec1(1:ntime) = dble(zcorr(1:ntime,2,ilead))  ! x: C- - real part
   dvec2(1:ntime) = v3s(itraj,1:ntime,ispin)       ! h: v3
   call ddcon(dvec2, 1, dvec1, 1, dvec3, 1, ntime, ntime, 0, ntime, 1)    
   dvec1(1:ntime) = -dimag(zcorr(1:ntime,2,ilead)) ! x: C- - imag part
   call ddcon(dvec2, 1, dvec1, 1, dvec4, 1, ntime, ntime, 0, ntime, 1)    
   do it=1,ntime
      w3s(itraj,it,ispin) = dcmplx(dvec3(it), dvec4(it)) * dt
   end do  
!
   dvec1(1:ntime) = dble(zcorr(1:ntime,1,ilead))  ! x: C+ - real part
   dvec2(1:ntime) = v4s(itraj,1:ntime,ispin)       ! h: v1
   call ddcon(dvec2, 1, dvec1, 1, dvec3, 1, ntime, ntime, 0, ntime, 1)    
   dvec1(1:ntime) = -dimag(zcorr(1:ntime,1,ilead)) ! x: C+ - imag part
   call ddcon(dvec2, 1, dvec1, 1, dvec4, 1, ntime, ntime, 0, ntime, 1)    
   do it=1,ntime
      w4s(itraj,it,ispin) = dcmplx(dvec3(it), dvec4(it)) * dt
   end do  
end do
end do
!$OMP END PARALLEL DO
!$OMP BARRIER
w1s = w1s / dref**2
w2s = w2s / dref**2
w3s = w3s / dref**2
w4s = w4s / dref**2
!
rhosav = czero
curr1=czero
curr2=czero
curr3=czero
curr4=czero
on=OMP_GET_WTIME()
!$OMP PARALLEL DO default(none) shared(rhosav,rho1,curr1,curr2,curr3,curr4,e1u,e1d,u1,dt,cb,cd,ntraj,ntime,index_vac, &
!$OMP nspin,nlead,t12,tlam,mways,nrhog,egate,ton_gate,toff_gate,v1s,v2s,v3s,v4s,w1s,w2s,w3s,w4s) &
!$OMP private(itraj,it,tt,rhog1,drhog1,n1,n3,sspin,ispin,ctmp1,ctmp2,dtmp1,rgtmp1,rgtmp2, &
!$OMP curr1_1, curr2_2, curr3_3, curr4_4,Arho)
do itraj=1,ntraj
   rhog1 = czero
   rhog1(1:nrhog,1:nrhog,index_vac) = rho1(1:nrhog,1:nrhog)    
      curr1_1=czero
      curr2_2=czero
      curr3_3=czero
      curr4_4=czero 
   do it=1,ntime
      tt = dble(it-1) * dt
       rgtmp1=czero
       rgtmp2=czero
       drhog1=czero
         Arho=czero
!$OMP CRITICAL
      rhosav(1:nrhog,1:nrhog,it) = rhosav(1:nrhog,1:nrhog,it) + rhog1(1:nrhog,1:nrhog,index_vac)
      curr1(1:nrhog,1:nrhog,it)= curr1(1:nrhog,1:nrhog,it) + curr1_1(1:nrhog,1:nrhog)
      curr2(1:nrhog,1:nrhog,it)= curr2(1:nrhog,1:nrhog,it) + curr2_2(1:nrhog,1:nrhog)
      curr3(1:nrhog,1:nrhog,it)= curr3(1:nrhog,1:nrhog,it) + curr3_3(1:nrhog,1:nrhog)
      curr4(1:nrhog,1:nrhog,it)= curr4(1:nrhog,1:nrhog,it) + curr4_4(1:nrhog,1:nrhog)
!$OMP END CRITICAL
      curr1_1=czero
      curr2_2=czero
      curr3_3=czero
      curr4_4=czero
do sspin=1,nspin*nlead
if (sspin .eq. 1 .OR.  sspin .eq. 3) then
   n1=1
   n3=3
   ispin=1
elseif( sspin .eq.  2 .OR. sspin .eq. 4) then
    n1=2
    n3=4
    ispin=2
end if
      ctmp1= -cb*t12*tlam*(w3s(itraj,it,sspin)-eye*w1s(itraj,it,sspin))
      call zcrhog3('l', 'n', ispin, ctmp1,  rhog1,  czero, rgtmp1)
      call zxrhog('l', 'u', n1, cunity, rgtmp1, czero, rgtmp2)
!
      ctmp1= -cb*t12*tlam*(w4s(itraj,it,sspin)- eye*w2s(itraj,it,sspin))
      call zcrhog3('l', 'c', ispin, ctmp1,  rhog1,  czero, rgtmp1)
      call zxrhog('l', 'd', n3, cunity, rgtmp1, cunity, rgtmp2)
!
    if (sspin .eq. 1) then
      curr1_1(1:nrhog,1:nrhog)= curr1_1(1:nrhog,1:nrhog) + rgtmp2(1:nrhog,1:nrhog,index_vac)
    elseif(sspin .eq. 2) then
      curr2_2(1:nrhog,1:nrhog)= curr2_2(1:nrhog,1:nrhog) + rgtmp2(1:nrhog,1:nrhog,index_vac)
    elseif(sspin .eq. 3) then
      curr3_3(1:nrhog,1:nrhog)= curr3_3(1:nrhog,1:nrhog) + rgtmp2(1:nrhog,1:nrhog,index_vac)
    elseif(sspin .eq. 4) then
      curr4_4(1:nrhog,1:nrhog)= curr4_4(1:nrhog,1:nrhog) + rgtmp2(1:nrhog,1:nrhog,index_vac)
    end if
end do
!
      drhog1 = czero
!   
      dtmp1 = e1u 
      if ( dabs(egate) .gt. dpico .and. &
           tt .gt. ton_gate .and. tt .lt. toff_gate ) then
         dtmp1 = e1u + egate
      end if
      if ( dabs(dtmp1) .gt. dpico ) then
         ctmp1 = -eye * dtmp1 * dt
         call zcrhog3('l', 'n', 1, cunity,  rhog1,  czero, rgtmp1)
         call zcrhog3('l', 'c', 1,  ctmp1, rgtmp1, cunity, drhog1)
         call zcrhog3('r', 'c', 1, cunity,  rhog1,  czero, rgtmp1)
         call zcrhog3('r', 'n', 1, -ctmp1, rgtmp1, cunity, drhog1)
      end if
!
      dtmp1 = e1d 
      if ( dabs(egate) .gt. dpico .and. &
           tt .gt. ton_gate .and. tt .lt. toff_gate ) then
         dtmp1 = e1d + egate
      end if
      if ( dabs(dtmp1) .gt. dpico ) then
         ctmp1 = -eye * dtmp1 * dt
         call zcrhog3('l', 'n', 2, cunity,  rhog1,  czero, rgtmp1)
         call zcrhog3('l', 'c', 2,  ctmp1, rgtmp1, cunity, drhog1)
         call zcrhog3('r', 'c', 2, cunity,  rhog1,  czero, rgtmp1)
         call zcrhog3('r', 'n', 2, -ctmp1, rgtmp1, cunity, drhog1)
      end if
!
      if ( dabs(u1) .gt. dpico ) then
         ctmp1 = -eye * u1 * dt
         call zcrhog3('l', 'n', 2, cunity,  rhog1,  czero, rgtmp1)
         call zcrhog3('l', 'c', 2, cunity, rgtmp1,  czero, rgtmp2)
         call zcrhog3('l', 'n', 1, cunity, rgtmp2,  czero, rgtmp1)
         call zcrhog3('l', 'c', 1,  ctmp1, rgtmp1, cunity, drhog1)
         call zcrhog3('r', 'c', 1, cunity,  rhog1,  czero, rgtmp1)
         call zcrhog3('r', 'n', 1, cunity, rgtmp1,  czero, rgtmp2)
         call zcrhog3('r', 'c', 2, cunity, rgtmp2,  czero, rgtmp1)
         call zcrhog3('r', 'n', 2, -ctmp1, rgtmp1, cunity, drhog1) 
      end if
! compute the stochastic part for rho1
!
 do sspin=1,nspin*nlead
 if( sspin .eq. 1 .OR. sspin .eq. 3) then
         n1=1
         n3=3
         ispin=1
 elseif( sspin .eq. 2 .OR. sspin .eq. 4) then
         n1=2
         n3=4
         ispin=2
 end if
      ctmp1 = -eye * t12 * w2s(itraj,it,sspin)
      ctmp2 = t12 * w4s(itraj,it,sspin) * cunity
      ctmp1 = ctmp1 + ctmp2
      call zxrhog('l', 'd', n3, ctmp1, rhog1, czero, rgtmp1)
      ctmp1 = v1s(itraj,it,sspin) * cunity
      call zxrhog('l', 'd', n1, ctmp1, rhog1, cunity, rgtmp1)
      ctmp1 = cb * tlam * dt 
      call zcrhog3('l', 'c', ispin, ctmp1, rgtmp1, cunity, Arho)
!
      ctmp1 = cb * tlam * dt 
      call zcrhog3('l', 'n', ispin, ctmp1, rhog1, czero, rgtmp1)
      ctmp1 = eye * t12 * w1s(itraj,it,sspin)
      ctmp2 = -t12 * w3s(itraj,it,sspin) * cunity
      ctmp1 = ctmp1 + ctmp2
      call zxrhog('l', 'u', n1, ctmp1, rgtmp1, cunity, Arho) 
      ctmp1 = v2s(itraj,it,sspin) * cunity
      call zxrhog('l', 'u', n3, ctmp1, rgtmp1, cunity, Arho)
!
      ctmp1 = cd * tlam * dt
      call zcrhog3('r', 'c', ispin, ctmp1, rhog1, czero, rgtmp1)
      ctmp1 = -t12 * w2s(itraj,it,sspin) * cunity
      ctmp2 = -eye * t12 * w4s(itraj,it,sspin)
      ctmp1 = ctmp1 + ctmp2
      call zxrhog('r', 'd', n3, ctmp1, rgtmp1, cunity, Arho)
      ctmp1 = v3s(itraj,it,sspin) * cunity
      call zxrhog('r', 'd', n1, ctmp1, rgtmp1, cunity, Arho)
!
      ctmp1 = t12 * w1s(itraj,it,sspin) * cunity
      ctmp2 = eye * t12 * w3s(itraj,it,sspin)
      ctmp1 = ctmp1 + ctmp2
      call zxrhog('r', 'u', n1, ctmp1, rhog1, czero, rgtmp1)
      ctmp1 = v4s(itraj,it,sspin) * cunity
      call zxrhog('r', 'u', n3, ctmp1, rhog1, cunity, rgtmp1)
      ctmp1 = cd * tlam * dt
      call zcrhog3('r', 'n', ispin, ctmp1, rgtmp1, cunity, Arho)
!
end do
!
rhog1(1:nrhog,1:nrhog,1:mways)= rhog1(1:nrhog,1:nrhog,1:mways) + drhog1(1:nrhog,1:nrhog,1:mways) + Arho(1:nrhog,1:nrhog,1:mways)

end do
   write(6,*)'sde_euler17_open: done itraj ', itraj, 'Thread_Num=', OMP_GET_THREAD_NUM()
   call flush(6)
end do
!$OMP END PARALLEL DO
!$OMP BARRIER
off=OMP_GET_WTIME()
!
rhosav = rhosav / dble(ntraj)
curr1  = curr1/dble(ntraj)
curr2  = curr2/dble(ntraj)
curr3  = curr3/dble(ntraj)
curr4  = curr4/dble(ntraj)
do it=1,ntime
   write(9) ((rhosav(ni,nj,it), ni=1,nrhog), nj=1,nrhog)
end do
!
do it=1,ntime
   tt = dble(it - 1) * dt
   occu = dble(rhosav(2,2,it) + rhosav(4,4,it))
   occd = dble(rhosav(3,3,it) + rhosav(4,4,it))
   ctmp1 = czero
   do ni=1,nrhog
      ctmp1 = ctmp1 + rhosav(ni,ni,it)
   end do
!   write(*,*)tt, occ1, dble(ctmp1), dimag(ctmp1)
   write(8,518)tt, occu, occd, dble(ctmp1), dimag(ctmp1)
   call flush(8)
!
   write(6,*)'sde_euler17_open: berezin ', it, ctmp1
   call flush(6)
!
end do
do it=1,ntime-1
   tt=dble(it-1)*dt
   occu =(dble(rhosav(2,2,it+1) + rhosav(4,4,it+1)) - dble(rhosav(2,2,it) + rhosav(4,4,it)))/dt
   occd =(dble(rhosav(3,3,it+1) + rhosav(4,4,it+1)) - dble(rhosav(3,3,it) + rhosav(4,4,it)))/dt
   write(29,518)tt, occu, occd
end do
   call flush(29)
!
do it =1,ntime
   tt = dble(it -1) * dt
   left_spin1_curr= -160217.7d0*dble(curr1(1,1,it) + curr1(2,2,it) + curr1(3,3,it) + curr1(4,4,it))
   left_spin2_curr= -160217.7d0*dble(curr2(1,1,it) + curr2(2,2,it) + curr2(3,3,it) + curr2(4,4,it))
   right_spin1_curr = -160217.7d0*dble(curr3(1,1,it) + curr3(2,2,it) + curr3(3,3,it) + curr3(4,4,it))
   right_spin2_curr= -160217.7d0*dble(curr4(1,1,it) + curr4(2,2,it) + curr4(3,3,it) + curr4(4,4,it))
   write(19,518) tt, left_spin1_curr, right_spin1_curr, left_spin2_curr, right_spin2_curr, &
                 left_spin1_curr + left_spin2_curr, right_spin1_curr + right_spin2_curr
end do
call flush(19)
!
999 continue
!
close(8)
close(9)
518 format(f12.4, 2x, 10(e15.6e3, 1x))
write(*,*) 'Time recorded for OpenMP part=', off-on, 'Sec'
!
deallocate(w1s, w2s, w3s, w4s, STAT=istat)
deallocate(v1s, v2s, v3s, v4s, STAT=istat)
deallocate(rhog1, drhog1, rhosav,  STAT=istat)
deallocate(rgtmp1, rgtmp2, STAT=istat)
!
deallocate(dfront_up, drear_up, STAT=istat)
deallocate(dfront_dn, drear_dn, STAT=istat)
deallocate(inup, indn, STAT=istat)
deallocate(dvec1, dvec2, dvec3, dvec4, STAT=istat)
deallocate(zcorr, STAT=istat)
!
return
end subroutine sde_euler17_open
