subroutine sde_euler18
use matmod
use tmpmatmod
use sdemod
use sdemod2
use sdemod3
use anderson
use random
implicit none
include "../include/sizes"
include "../include/common"
!
integer :: it, istat, ispin, itraj, ni, nj, nk
real*8  :: tt 
real*8  :: occu, occd, occ1, occ2
real*8  :: tlam, dcp(2), dcm(2), dtmp1
real*8, allocatable  :: dvec1(:), dvec2(:), dvec3(:), dvec4(:)
complex*16, allocatable :: w1s(:,:,:), w2s(:,:,:)
complex*16, allocatable :: w3s(:,:,:), w4s(:,:,:)
complex*16 :: cb, cd, ctmp1, ctmp2, ctmp3
integer, allocatable :: iseed(:)
complex*16, allocatable :: rgtmp1(:,:,:), rgtmp2(:,:,:)
complex*16, allocatable :: zcorr(:,:)
!
namelist / seedinfo / lread_seed, noffset_seed
!
allocate(w1s(ntraj,ntime,nspin), w2s(ntraj,ntime,nspin), &
         w3s(ntraj,ntime,nspin), w4s(ntraj,ntime,nspin), STAT=istat)
allocate(dvec1(ntime), dvec2(ntime), dvec3(ntime), dvec4(ntime), STAT=istat)
allocate(zcorr(ntime,nsgn), STAT=istat)
!
open(unit=8, file='population.dat', status='unknown')
rewind(8)
open(unit=9, file='rhoavg.data', form='unformatted', status='unknown')
rewind(9)
!
write(6,*)
write(6,*)'sde_euler18: time evolution '
write(6,*)'sde_euler18:   dt = ', dt
write(6,*)'sde_euler18: tmax = ', dble(ntime-1)*dt
write(6,*)'sde_euler18:   e1u = ', e1u  
write(6,*)'sde_euler18:   e1d = ', e1d  
write(6,*)'sde_euler18:    u1 = ', u1   
write(6,*)'sde_euler18: engy2 = ', engy2
write(6,*)'sde_euler18: t12   = ', t12  
write(6,*)'sde_euler18: ntraj = ', ntraj
call flush(6)
!
nrhog = 4
cb    = dsqrt(5.d-1) * dcmplx(1.d0, -1.d0)
cd    = dsqrt(5.d-1) * dcmplx(1.d0,  1.d0)
!
e1u   = e1u
e1d   = e1d
u1    = u1
tlam  = dsqrt(t12)
!
allocate(v1s(ntraj,ntime,nspin), v2s(ntraj,ntime,nspin), &
         v3s(ntraj,ntime,nspin), v4s(ntraj,ntime,nspin), STAT=istat)
!
call pre_berezin3
!write(6,*)'sde_euler18: pre_berezin done '
!call flush(6)
!
allocate(rhog1(nrhog,nrhog,mways), STAT=istat)
allocate(drhog1(nrhog,nrhog,mways), STAT=istat)
allocate(rhosav(nrhog,nrhog,ntime), STAT=istat)
!
allocate(rgtmp1(nrhog,nrhog,mways), rgtmp2(nrhog,nrhog,mways), STAT=istat)
!
occu = dble(rho2(2,2) + rho2(4,4))
occd = dble(rho2(3,3) + rho2(4,4))
dcp(1) = occu
dcp(2) = occd
dcm(1:nspin) = 1.d0 - dcp(1:nspin)
write(6,*)
write(6,*)'sde_euler18: dcp = ', dcp(1), dcp(2)
write(6,*)'sde_euler18: dcm = ', dcm(1), dcm(2)
call flush(6)
!
!   goto 999
!
lread_seed = .false.
noffset_seed = 0
rewind(5)
read(5, seedinfo, end=100)
100 continue
!
if (lread_seed) then
   open(unit=11, file='seed.data', form='unformatted', status='unknown')
   call RANDOM_SEED(size=nk)
   allocate(iseed(nk), STAT=istat)
!
   do ispin=1,nspin  ! no indent
   do it=1,ntimE
      read(11) (iseed(ni), ni=1,nk)
      call RANDOM_SEED(put=iseed)
      do ni=1,noffset_seed
         dtmp1 = random_normal()
      end do
      do itraj=1,ntraj   
         v1s(itraj,it,ispin) = random_normal()
      end do
!
      read(11) (iseed(ni), ni=1,nk)
      call RANDOM_SEED(put=iseed)
      do ni=1,noffset_seed
         dtmp1 = random_normal()
      end do
      do itraj=1,ntraj   
         v2s(itraj,it,ispin) = random_normal()
      end do
!
      read(11) (iseed(ni), ni=1,nk)
      call RANDOM_SEED(put=iseed)
      do ni=1,noffset_seed
         dtmp1 = random_normal()
      end do
      do itraj=1,ntraj   
         v3s(itraj,it,ispin) = random_normal()
      end do
!
      read(11) (iseed(ni), ni=1,nk)
      call RANDOM_SEED(put=iseed)
      do ni=1,noffset_seed
         dtmp1 = random_normal()
      end do
      do itraj=1,ntraj   
         v4s(itraj,it,ispin) = random_normal()
      end do
   end do
   end do ! loop ispin
   close(11)
   deallocate(iseed, STAT=istat)
   write(6,*)
   write(6,*)'sde_euler18: random seed read from file '
   write(6,*)'sde_euler18: with ', noffset_seed, ' void rand num '
   call flush(6)
!
else
   open(unit=11, file='seed.data', form='unformatted', status='unknown')
   rewind(11)
   !
   call RANDOM_SEED(size=nk)
   allocate(iseed(nk), STAT=istat)
   !
   do ispin=1,nspin
   do it=1,ntime
      call init_random_seed_out(nk, iseed)
      do itraj=1,ntraj   
         v1s(itraj,it,ispin) = random_normal()
      end do
      write(11) (iseed(ni), ni=1,nk)
      call delay(51200)
   !
      call init_random_seed_out(nk, iseed)
      do itraj=1,ntraj   
         v2s(itraj,it,ispin) = random_normal()
      end do
      write(11) (iseed(ni), ni=1,nk)
      call delay(51200)
   !
      call init_random_seed_out(nk, iseed)
      do itraj=1,ntraj   
         v3s(itraj,it,ispin) = random_normal()
      end do
      write(11) (iseed(ni), ni=1,nk)
      call delay(51200)
   !
      call init_random_seed_out(nk, iseed)
      do itraj=1,ntraj   
         v4s(itraj,it,ispin) = random_normal()
      end do
      write(11) (iseed(ni), ni=1,nk)
      call delay(51200)
   end do
   end do
   close(11)
   deallocate(iseed, STAT=istat)
   write(6,*)
   write(6,*)'sde_euler18: random seeds generated and saved '
   call flush(6)
end if
!
v1s = v1s / dsqrt(dt)
v2s = v2s / dsqrt(dt)
v3s = v3s / dsqrt(dt)
v4s = v4s / dsqrt(dt)
!
zcorr = czero
do it=1,ntime
   tt = dble(it - 1) * dt
   zcorr(it,1) = cdexp( eye * engy2 * tt ) / t12**2
   zcorr(it,2) = cdexp(-eye * engy2 * tt ) / t12**2
end do
!
w1s = czero  
w2s = czero
w3s = czero
w4s = czero
!
do ispin=1,nspin
do itraj=1,ntraj
   dvec1(1:ntime) = dble(zcorr(1:ntime,1))  ! x: C+ - real part
   dvec2(1:ntime) = v1s(itraj,1:ntime,ispin)       ! h: v1
   call ddcon(dvec2, 1, dvec1, 1, dvec3, 1, ntime, ntime, 0, ntime, 1)    
   dvec1(1:ntime) = dimag(zcorr(1:ntime,1)) ! x: C+ - imag part
   call ddcon(dvec2, 1, dvec1, 1, dvec4, 1, ntime, ntime, 0, ntime, 1)    
   do it=2,ntime
      w1s(itraj,it,ispin) = dcmplx(dvec3(it-1), dvec4(it-1)) * dt
   end do  
!
   dvec1(1:ntime) = dble(zcorr(1:ntime,2))  ! x: C- - real part
   dvec2(1:ntime) = v2s(itraj,1:ntime,ispin)       ! h: v2
   call ddcon(dvec2, 1, dvec1, 1, dvec3, 1, ntime, ntime, 0, ntime, 1)    
   dvec1(1:ntime) = dimag(zcorr(1:ntime,2)) ! x: C- - imag part
   call ddcon(dvec2, 1, dvec1, 1, dvec4, 1, ntime, ntime, 0, ntime, 1)    
   do it=2,ntime
      w2s(itraj,it,ispin) = dcmplx(dvec3(it-1), dvec4(it-1)) * dt
   end do  
!
   dvec1(1:ntime) = dble(zcorr(1:ntime,2))  ! x: C- - real part
   dvec2(1:ntime) = v3s(itraj,1:ntime,ispin)       ! h: v3
   call ddcon(dvec2, 1, dvec1, 1, dvec3, 1, ntime, ntime, 0, ntime, 1)    
   dvec1(1:ntime) = -dimag(zcorr(1:ntime,2)) ! x: C- - imag part
   call ddcon(dvec2, 1, dvec1, 1, dvec4, 1, ntime, ntime, 0, ntime, 1)    
   do it=2,ntime
      w3s(itraj,it,ispin) = dcmplx(dvec3(it-1), dvec4(it-1)) * dt
   end do  
!
   dvec1(1:ntime) = dble(zcorr(1:ntime,1))  ! x: C+ - real part
   dvec2(1:ntime) = v4s(itraj,1:ntime,ispin)       ! h: v1
   call ddcon(dvec2, 1, dvec1, 1, dvec3, 1, ntime, ntime, 0, ntime, 1)    
   dvec1(1:ntime) = -dimag(zcorr(1:ntime,1)) ! x: C+ - imag part
   call ddcon(dvec2, 1, dvec1, 1, dvec4, 1, ntime, ntime, 0, ntime, 1)    
   do it=2,ntime
      w4s(itraj,it,ispin) = dcmplx(dvec3(it-1), dvec4(it-1)) * dt
   end do  
end do
end do
!
rhosav = czero
!
do itraj=1,ntraj
   rhog1 = czero
   rhog1(1:nrhog,1:nrhog,index_vac) = rho1(1:nrhog,1:nrhog)    
!
   do it=1,ntime
      tt = dble(it-1) * dt
!
      rhosav(1:nrhog,1:nrhog,it) = rhosav(1:nrhog,1:nrhog,it) + rhog1(1:nrhog,1:nrhog,index_vac)
!
      drhog1 = czero
!   
      if ( dabs(e1u) .gt. dpico ) then
         ctmp1 = -eye * e1u * dt
         call zcrhog3('l', 'n', 1, cunity,  rhog1,  czero, rgtmp1)
         call zcrhog3('l', 'c', 1,  ctmp1, rgtmp1, cunity, drhog1)
         call zcrhog3('r', 'c', 1, cunity,  rhog1,  czero, rgtmp1)
         call zcrhog3('r', 'n', 1, -ctmp1, rgtmp1, cunity, drhog1)
      end if
!
      if ( dabs(e1d) .gt. dpico ) then
         ctmp1 = -eye * e1d * dt
         call zcrhog3('l', 'n', 2, cunity,  rhog1,  czero, rgtmp1)
         call zcrhog3('l', 'c', 2,  ctmp1, rgtmp1, cunity, drhog1)
         call zcrhog3('r', 'c', 2, cunity,  rhog1,  czero, rgtmp1)
         call zcrhog3('r', 'n', 2, -ctmp1, rgtmp1, cunity, drhog1)
      end if
!
      if ( dabs(u1) .gt. dpico ) then
         ctmp1 = -eye * u1 * dt
         call zcrhog3('l', 'n', 2, cunity,  rhog1,  czero, rgtmp1)
         call zcrhog3('l', 'c', 2, cunity, rgtmp1,  czero, rgtmp2)
         call zcrhog3('l', 'n', 1, cunity, rgtmp2,  czero, rgtmp1)
         call zcrhog3('l', 'c', 1,  ctmp1, rgtmp1, cunity, drhog1)
         call zcrhog3('r', 'c', 1, cunity,  rhog1,  czero, rgtmp1)
         call zcrhog3('r', 'n', 1, cunity, rgtmp1,  czero, rgtmp2)
         call zcrhog3('r', 'c', 2, cunity, rgtmp2,  czero, rgtmp1)
         call zcrhog3('r', 'n', 2, -ctmp1, rgtmp1, cunity, drhog1) 
      end if
!
! compute the stochastic part for rho1
!
      ispin = 1
      ctmp1 = -eye * t12 * w2s(itraj,it,ispin) * dcm(ispin)
      ctmp2 = t12 * w4s(itraj,it,ispin) * cunity * dcp(ispin)
      ctmp1 = ctmp1 + ctmp2
      call zxrhog('l', 'd', 3, ctmp1, rhog1, czero, rgtmp1)
      ctmp1 = v1s(itraj,it,ispin) * cunity
      call zxrhog('l', 'd', 1, ctmp1, rhog1, cunity, rgtmp1)
      ctmp1 = cb * tlam * dt 
      call zcrhog3('l', 'c', ispin, ctmp1, rgtmp1, cunity, drhog1)
!
      ispin = 2
      ctmp1 = -eye * t12 * w2s(itraj,it,ispin) * dcm(ispin)
      ctmp2 = t12 * w4s(itraj,it,ispin) * cunity * dcp(ispin)
      ctmp1 = ctmp1 + ctmp2
      call zxrhog('l', 'd', 4, ctmp1, rhog1, czero, rgtmp1)
      ctmp1 = v1s(itraj,it,ispin) * cunity
      call zxrhog('l', 'd', 2, ctmp1, rhog1, cunity, rgtmp1)
      ctmp1 = cb * tlam * dt 
      call zcrhog3('l', 'c', ispin, ctmp1, rgtmp1, cunity, drhog1)
!
      ispin = 1
      ctmp1 = cb * tlam * dt 
      call zcrhog3('l', 'n', ispin, ctmp1, rhog1, czero, rgtmp1)
      ctmp1 = eye * t12 * w1s(itraj,it,ispin) * dcp(ispin)
      ctmp2 = -t12 * w3s(itraj,it,ispin) * cunity * dcm(ispin)
      ctmp1 = ctmp1 + ctmp2
      call zxrhog('l', 'u', 1, ctmp1, rgtmp1, cunity, drhog1) 
      Ctmp1 = v2s(itraj,it,ispin) * cunity
      call zxrhog('l', 'u', 3, ctmp1, rgtmp1, cunity, drhog1)
!
      ispin = 2
      ctmp1 = cb * tlam * dt 
      call zcrhog3('l', 'n', ispin, ctmp1, rhog1, czero, rgtmp1)
      ctmp1 = eye * t12 * w1s(itraj,it,ispin) * dcp(ispin)
      ctmp2 = -t12 * w3s(itraj,it,ispin) * cunity * dcm(ispin)
      ctmp1 = ctmp1 + ctmp2
      call zxrhog('l', 'u', 2, ctmp1, rgtmp1, cunity, drhog1) 
      ctmp1 = v2s(itraj,it,ispin) * cunity
      call zxrhog('l', 'u', 4, ctmp1, rgtmp1, cunity, drhog1)
!
      ispin = 1
      ctmp1 = cd * tlam * dt
      call zcrhog3('r', 'c', ispin, ctmp1, rhog1, czero, rgtmp1)
      ctmp1 = -t12 * w2s(itraj,it,ispin) * cunity * dcm(ispin)
      ctmp2 = -eye * t12 * w4s(itraj,it,ispin) * dcp(ispin)
      ctmp1 = ctmp1 + ctmp2
      call zxrhog('r', 'd', 3, ctmp1, rgtmp1, cunity, drhog1)
      ctmp1 = v3s(itraj,it,ispin) * cunity
      call zxrhog('r', 'd', 1, ctmp1, rgtmp1, cunity, drhog1)
!
      ispin = 2
      ctmp1 = cd * tlam * dt
      call zcrhog3('r', 'c', ispin, ctmp1, rhog1, czero, rgtmp1)
      ctmp1 = -t12 * w2s(itraj,it,ispin) * cunity * dcm(ispin)
      ctmp2 = -eye * t12 * w4s(itraj,it,ispin) * dcp(ispin)
      ctmp1 = ctmp1 + ctmp2
      call zxrhog('r', 'd', 4, ctmp1, rgtmp1, cunity, drhog1)
      ctmp1 = v3s(itraj,it,ispin) * cunity
      call zxrhog('r', 'd', 2, ctmp1, rgtmp1, cunity, drhog1)
!
      ispin = 1
      ctmp1 = t12 * w1s(itraj,it,ispin) * cunity * dcp(ispin)
      ctmp2 = eye * t12 * w3s(itraj,it,ispin) * dcm(ispin)
      ctmp1 = ctmp1 + ctmp2
      call zxrhog('r', 'u', 1, ctmp1, rhog1, czero, rgtmp1)
      ctmp1 = v4s(itraj,it,ispin) * cunity 
      call zxrhog('r', 'u', 3, ctmp1, rhog1, cunity, rgtmp1)
      ctmp1 = cd * tlam * dt
      call zcrhog3('r', 'n', ispin, ctmp1, rgtmp1, cunity, drhog1)
!
      ispin = 2
      ctmp1 = t12 * w1s(itraj,it,ispin) * cunity * dcp(ispin)
      ctmp2 = eye * t12 * w3s(itraj,it,ispin) * dcm(ispin)
      ctmp1 = ctmp1 + ctmp2
      call zxrhog('r', 'u', 2, ctmp1, rhog1, czero, rgtmp1)
      ctmp1 = v4s(itraj,it,ispin) * cunity 
      call zxrhog('r', 'u', 4, ctmp1, rhog1, cunity, rgtmp1)
      ctmp1 = cd * tlam * dt
      call zcrhog3('r', 'n', ispin, ctmp1, rgtmp1, cunity, drhog1)
!
      rhog1(1:nrhog,1:nrhog,1:mways) = rhog1(1:nrhog,1:nrhog,1:mways) + drhog1(1:nrhog,1:nrhog,1:mways)   
!
   end do
   write(6,*)'sde_euler18: done itraj ', itraj
   call flush(6)
end do
!
rhosav = rhosav / dble(ntraj)
do it=1,ntime
   write(9) ((rhosav(ni,nj,it), ni=1,nrhog), nj=1,nrhog)
end do
!
do it=1,ntime
   tt = dble(it - 1) * dt
   occu = dble(rhosav(2,2,it) + rhosav(4,4,it))
   occd = dble(rhosav(3,3,it) + rhosav(4,4,it))
   ctmp1 = czero
   do ni=1,nrhog
      ctmp1 = ctmp1 + rhosav(ni,ni,it)
   end do
!   write(8,518)tt, occ1, dble(ctmp1), dimag(ctmp1)
   write(8,518)tt, occu, occd, dble(ctmp1), dimag(ctmp1)
   call flush(8)
!
   write(6,*)'sde_euler18: berezin ', it, ctmp1
   call flush(6)
!
end do
!
999 continue
!
close(8)
close(9)
518 format(f12.4, 2x, 10(e15.6e3, 1x))
!
deallocate(w1s, w2s, w3s, w4s, STAT=istat)
deallocate(v1s, v2s, v3s, v4s, STAT=istat)
deallocate(rhog1, drhog1, rhosav, STAT=istat)
deallocate(rgtmp1, rgtmp2, STAT=istat)
!
deallocate(dfront_up, drear_up, STAT=istat)
deallocate(dfront_dn, drear_dn, STAT=istat)
deallocate(inup, indn, STAT=istat)
deallocate(dvec1, dvec2, dvec3, dvec4, STAT=istat)
deallocate(zcorr, STAT=istat)
!
return
end subroutine sde_euler18
