subroutine zcrhog3(sidea, transa, ispin, zalpha, b, zbeta, c)
use matmod
use tmpmatmod
use sdemod2
use anderson
implicit none
include '../include/sizes'
include '../include/common'
!
character*1, intent(in)   :: sidea, transa
integer,    intent(in)    :: ispin
complex*16, intent(in)    :: zalpha, zbeta, b(nrhog,nrhog,mways)
complex*16, intent(inout) :: c(nrhog,nrhog,mways)
!
integer  :: ni, nj, nk, mi, mj, mk, iopr
logical  :: lsame
external :: lsame
logical  :: nota, conja, lefta, righta
complex*16 :: ctmp1
!
lefta  = lsame(sidea,  'L')
righta = lsame(sidea,  'R')
nota   = lsame(transa, 'N')
conja  = lsame(transa, 'C')
!
if ( (.not. nota) .and. (.not. conja) ) then
  write(6,*)
  write(6,*)' error input for transa in zcrhog3', transa
  stop
end if
!
if ( (.not. lefta) .and. (.not. righta) ) then
  write(6,*)
  write(6,*)' error input for sidea in zcrhog3', sidea
  stop
end if
!
if (nota .and. ispin .eq. 1) then
   iopr = 1
else if (nota .and. ispin .eq. 2) then
   iopr = 2
else if (conja .and. ispin .eq. 1) then
   iopr = 3
else if (conja .and. ispin .eq. 2) then
   iopr = 4
else 
   write(6,*)'zcrhog3: unknown iopr '
   stop
end if
!
c(1:nrhog,1:nrhog,1:mways) = zbeta * c(1:nrhog,1:nrhog,1:mways)
!
if (lefta) then
   do nj=1,nnz_a
      mi = irow_a(nj,iopr)
      mk = icol_a(nj,iopr)
      ctmp1 = dval_a(nj,iopr) * zalpha
      do ni=1,mways
         do mj=1,nsys_a
            c(mi,mj,ni) = c(mi,mj,ni) + ctmp1 * b(mk,mj,ni)
         end do
      end do  
   end do
else 
   do nj=1,nnz_a
      mk = irow_a(nj,iopr)
      mj = icol_a(nj,iopr)
      ctmp1 = dval_a(nj,iopr) * zalpha
      do ni=1,mways
         do mi=1,nsys_a
            c(mi,mj,ni) = c(mi,mj,ni) + ctmp1 * b(mi,mk,ni)
         end do
      end do  
   end do
end if
!
return
end subroutine zcrhog3
